//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		Create.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMELٳ)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		۸т'update'۸тpĖړIΏAVRɑ邱Ƃł
//				Íꂽ̧ق̍쐬gp҂ɋ܂B۸т͌`Ԑ
//				̧ Ұɏ]'bootldr'`Ԑݒ肷̂ƁADESÍp
//				̂̂ƂŁA'bootldr'p2̧ق쐬܂B
//
//				葽̏ɂĂ͉pLqQƂĂB
//
// ̑:
//=============================================================================

#include <stdio.h>
#include <stdlib.h>
#include "CreateException.h"
#include "ConfigParser.h"
#include "MemoryMap.h"
#include "OutputWriter.h"

//=============================================================================
// 쌠Aɕ\܂B

char *copyrightString =
	"\ncreate v1.0 - Copyright (C) 2003 Atmel Corporation\n\n";

//=============================================================================
// S^Ȃꍇɕ\g

char *usageString =
	"Usage: create <arguments>\n\n"
	"  -c filename.ext   Configuration file.\n"
	"  -d                Erase flash memory before update.\n"
	"  -e filename.ext   EEPROM file in Intel HEX format.\n"
	"  -f filename.ext   Application section file in Intel HEX format.\n"
	"  -h filename.ext   Bootloader header file in C-syntax.\n"
	"  -k filename.ext   DES key table in C-syntax.\n"
	"  -l [BLB01] [BLB02] [BLB11] [BLB12]\n"
	"                    Lock bits.\n"
	"  -n                Add nonsense records.\n"
	"  -o filename.ext   Encrypted file.\n"
	"  -?                Display this help.\n";


//=============================================================================
// AŎn܂܂!

int main(int argc, char* argv[])
{
	printf(copyrightString);

	char *outputFilename = NULL;
	char *flashFilename = NULL;
	char *eepromFilename = NULL;
	char *configFilename = NULL;
	char *headerFilename = NULL;
	char *keyFilename = NULL;

	unsigned char lockBits = 0xff;
	bool updateLockBits = false;

	bool eraseFlash = false;
	bool nonsenseRecords = false;

	// ŏ̖ߍs΂(̕۸т̖O܂݂܂B)
	argv++;
	argc--;

	// S^Ȃꍇ͎g\܂B
	if (argc == 0)
	{
		printf(usageString);
		return -1;
	}

	try {
		int argIndex = 0;

		// ^ꂽSĂ̈
		while (argIndex < argc)
		{
			// !
			if (strstr(argv[argIndex], "-?"))
			{
				printf(usageString);
				argIndex++;
			}

			// `Ԑݒ̧
			else if (strstr(argv[argIndex], "-c"))
			{
				configFilename = argv[++argIndex];
				argIndex++;
			}

			// ۸ݸނ̑Oɉp̈
			else if (strstr(argv[argIndex], "-d"))
			{
				argIndex++;
				eraseFlash = true;
			}

			// EEPROMȩ
			else if (strstr(argv[argIndex], "-e"))
			{
				eepromFilename = argv[++argIndex];
				argIndex++;
			}

			// ׯ ؓȩ(p̈p)
			else if (strstr(argv[argIndex], "-f"))
			{
				flashFilename = argv[++argIndex];
				argIndex++;
			}

			// ͯ ̧
			else if (strstr(argv[argIndex], "-h"))
			{
				headerFilename = argv[++argIndex];
				argIndex++;
			}

			// ̧
			else if (strstr(argv[argIndex], "-k"))
			{
				keyFilename = argv[++argIndex];
				argIndex++;
			}

			// {ޯ
			else if (strstr(argv[argIndex], "-l"))
			{
				updateLockBits = true;
				while (++argIndex < argc)
				{
					if(strstr(argv[argIndex], "BLB01"))
						lockBits &= 0xFB;
					else if(strstr(argv[argIndex], "BLB02"))
						lockBits &= 0xF7;
					else if(strstr(argv[argIndex], "BLB11"))
						lockBits &= 0xEF;
					else if(strstr(argv[argIndex], "BLB12"))
						lockBits &= 0xDF;
					else
						break;
				}
			}

			// smL^ǉ
			else if (strstr(argv[argIndex], "-n"))
			{
				argIndex++;
				nonsenseRecords = true;
			}

			// o̧(Ío)
			else if (strstr(argv[argIndex], "-o"))
			{
				outputFilename = argv[++argIndex];
				argIndex++;
			}

			// m̈ȂAO!
			else
				throw new CreateException(ERROR_UNKNOWN_ARGUMENT,
					argv[argIndex]);
		}

		// o
		printf("Using the following arguments:\n");
		if (configFilename) printf("  Config filename: %s\n", configFilename);
		if (flashFilename)	printf("  Flash filename:  %s\n", flashFilename);
		if (eepromFilename)	printf("  EEPROM filename: %s\n", eepromFilename);
		if (outputFilename)	printf("  Output filename: %s\n", outputFilename);
		if (headerFilename)	printf("  Header filename: %s\n", headerFilename);
		if (keyFilename)	printf("  Key filename:    %s\n", keyFilename);

		if (updateLockBits)
		{
			printf("  Lock bits:      ");
			if(lockBits == 255)		printf(" NONE");
			if((~lockBits) & 0x20)	printf(" BLB12");
			if((~lockBits) & 0x10)	printf(" BLB11");
			if((~lockBits) & 0x08)	printf(" BLB02");
			if((~lockBits) & 0x04)	printf(" BLB01"
				"\n    - WARNING! Setting BLB01 will writeprotect the "
					"application section.");
			printf("\n");
		}

		if (eraseFlash)
			printf("  - Application section will be erased.\n");

		if (nonsenseRecords)
			printf(
				"  - Nonsense records will be added between payload records.\n"
			);

		printf("\n\n");

		if (!configFilename)
			throw new CreateException(ERROR_CONFIG_NOT_DEFINED, "");

		// `Ԑݒ̧ى
		ConfigParser *parser = new ConfigParser(configFilename);

		// mFpɒoҰo
		printf("The following configuration will be used:\n");
		printf("  Encryption      = ");
		if (parser->getKeyCount() == 0)
			printf("No encryption\n");
		else
			printf("%d-bit %s, cipher block chaining mode\n",
				parser->getKeyCount() * 56,
				(parser->getKeyCount() > 1) ? "Triple-DES" : "Simple-DES");

		for (int i = 0; i < parser->getKeyCount(); i++)
			printf("    KEY%d          = %s\n", i + 1,
				parser->getKey(i).toHexString());

		if (parser->getKeyCount() > 0)
		{
			printf("  INITIAL_VECTOR  = %s\n",
				parser->getInitialVector().toHexString());
		}

		printf("  SIGNATURE       = %s\n",
			parser->getSignature().toHexString());

		printf("  PAGE_SIZE       = %d\n", parser->getPageSize());
		printf("  MEM_SIZE        = %d\n", parser->getMemSize());
		printf("  CRC_ENABLE      = %s\n",
			parser->getCRCFlashEnable() ? "YES" : "NO");

		printf("\n");

		// ׯ ؂EEPROM̓ȩقǂݍ
		MemoryMap *flash;
		if (flashFilename)
		{
			flash =	new MemoryMap(
				flashFilename, 0, parser->getMemSize() - 1, 0xff);

			printf("Read %s!\n", flashFilename);
		}
		else
			flash = NULL;

		MemoryMap *eeprom;
		if (eepromFilename)
		{
			eeprom = new MemoryMap(eepromFilename, 0xff);
			printf("Read %s!\n", eepromFilename);
		}
		else
			eeprom = NULL;

		OutputWriter *writer = new OutputWriter(flash, eeprom,
			parser->getPageSize(), parser->getKeys(),
			parser->getInitialVector(), parser->getSignature(),
			updateLockBits, lockBits, parser->getMemSize(),
			parser->getKeyCount(), parser->getCRCFlashEnable(),
			parser->getCRCFlashEnable() | eraseFlash, nonsenseRecords
		);

		// ُ̧
		if (keyFilename)
		{
			writer->writeKeyFile(keyFilename);
			printf("Wrote %s!\n", keyFilename);
		}

		// ͯ ُ̧
		if (headerFilename)
		{
			writer->writeHeaderFile(headerFilename);
			printf("Wrote %s!\n", headerFilename);
		}

		// Íoُ̧
		if (outputFilename)
		{
			writer->writeOutputFile(outputFilename);
			printf("Wrote %s!\n", outputFilename);
		}

		printf("\nCreate finished successfully.");
		return ERROR_OK;
	}

	catch (CreateException *e)
	{
		printf("Error: %s\n\n", e->getReason());
		printf("Type \"create <enter>\" for usage.\n");

		int returnCode = e->getCode();
		delete(e);

		return returnCode;
	}
}
