//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		DataBuffer.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMELٳ)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		DataBuffer׽͕Ȃchar̓IɏՕgp҂ɋ܂B
//				̸׽basic_string`ɊÂ܂B16i`ƕȂ
//				charɏՕԂ̕ϊɊւ@\ǉA@\͊{Ibasic_
//				stringƓłB
//
// ̑:
//=============================================================================

#include "DataBuffer.h"
#include <stdlib.h>

//=============================================================================
// ̊ɏՕ쐬邽߂̕Wݽ׸

DataBuffer::DataBuffer() : ByteString(), hexStringM(NULL)
{
	// 
}

//=============================================================================
// ݽ׸

DataBuffer::DataBuffer(const DataBuffer& buffer) : ByteString(),
	hexStringM(NULL)
{
	operator=(buffer);
}

//=============================================================================
// 16iDataBufferɕϊݽ׸

DataBuffer::DataBuffer(char *hexString) : ByteString(), hexStringM(NULL)
{
	parse(hexString, strlen(hexString));
}

//=============================================================================
// 16i̕DataBufferɕϊݽ׸

DataBuffer::DataBuffer(char *hexString, size_t length) : ByteString(),
	hexStringM(NULL)
{
	parse(hexString, length);
}

//=============================================================================
// Ȃchar̔zDataBufferɕϊݽ׸

DataBuffer::DataBuffer(unsigned char *data, size_t length)
	: ByteString(data, length), hexStringM(NULL)
{
	// 
}

//=============================================================================
// 'fill'ް܂'size'DataBuffer쐬ݽ׸

DataBuffer::DataBuffer(size_t size, unsigned char fill) :
	ByteString(size, fill), hexStringM(NULL)
{
	// 
}

//=============================================================================
// ޽׸

DataBuffer::~DataBuffer()
{
	deleteHexString();
}

//=============================================================================
// DataBuffer^̒lɑ΂Zq

DataBuffer& DataBuffer::operator = (const DataBuffer& buffer)
{
	deleteHexString();

	ByteString::operator=(buffer);

	return *this;
}

//=============================================================================
// char *()^rvalueɑ΂Zq

DataBuffer& DataBuffer::operator = (char *rvalue)
{
	parse(rvalue, strlen(rvalue));

	return *this;
}

//=============================================================================
// ByteString^̒lɑ΂Zq

DataBuffer& DataBuffer::operator = (const ByteString& string)
{
	ByteString::operator =(string);

	return *this;
}

//=============================================================================
// hexStringꎞɏՕ苎

void DataBuffer::deleteHexString()
{
	if (hexStringM)
		delete hexStringM;

	hexStringM = NULL;
}

//=============================================================================
// hexStringɊւVKɏՕ쐬

void DataBuffer::newHexString(size_t length)
{
	// ꂪɊtς݂ȂA폜
	deleteHexString();
	hexStringM = new char[length];
}

//=============================================================================
// 16i܂ޕ͂ČʂɏՕɊi[

void DataBuffer::parse(char *hexString, size_t length)
{
	char hexByte[] = {0, 0, 0};
	int value;

	// ɏՕ
	erase();

	// 216iAƈx1޲Ă͂ĂɏՕɒǉ
	for (int i = 0; i < length; i += 2)
	{
		strncpy(hexByte, &hexString[i], 2);
		sscanf(hexByte, "%x", &value);
		operator+=(value);
	}
}

//=============================================================================
// ɏՕ("0123456789abcdef"̂悤)ASCII 16iɕϊ

char *DataBuffer::toHexString(unsigned int first, int length)
{
	unsigned int i, j;
	unsigned int last;

	if (length == 0)
		return "";
	else if (length < 0)
		length = size();

	last = first + length;

	newHexString(length * 2 + 1);

	for (i = first, j = 0; i < last && i < size(); i++, j += 2)
		sprintf(&hexStringM[j], "%.02X", (*this)[i]);

	return hexStringM;
}

//=============================================================================
// ɏՕ("0x01, 0x23, 0x34, `"̂悤C`16iɕϊ

char *DataBuffer::toCHexString(unsigned int first, int length)
{
	unsigned int i, j;
	unsigned int last;

	if (length == 0)
		return "";
	else if (length < 0)
		length = size();

	last = first + length;

	newHexString(length * 6);

	for (i = first, j = 0; i < last; i++, j += 6)
		if (i == size() - 1)
			sprintf(&hexStringM[j], "0x%.2x", (*this)[i]);
		else
			sprintf(&hexStringM[j], "0x%.2x, ", (*this)[i]);

	return hexStringM;
}
