//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		DataBuffer.h
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		DataBuffer׽͕Ȃchar̓IɏՕgp҂ɋ܂B
//				̸׽basic_string`ɊÂ܂B16i`ƕȂ
//				charɏՕԂ̕ϊɊւ@\ǉA@\͊{Ibasic_
//				stringƓłB
//
// ̑:
//=============================================================================

#ifndef DATABUFFER_H
#define DATABUFFER_H

#include <string>

typedef std::basic_string<unsigned char, std::char_traits<unsigned char>, std::allocator<unsigned char> > ByteString;

class DataBuffer : public ByteString
{
public:
	DataBuffer();
	DataBuffer(const DataBuffer& buffer);
	DataBuffer(char *hexString);
	DataBuffer(char *hexString, size_t length);
	DataBuffer(unsigned char *data, size_t length);
	DataBuffer(size_t size, unsigned char fill = 0);

	~DataBuffer();

	DataBuffer& operator =(const DataBuffer& buffer);
	DataBuffer& operator =(char *rvalue);
	DataBuffer& operator =(const ByteString& string);

	char *toHexString(unsigned int first = 0, int length = -1);
	char *toCHexString(unsigned int first = 0, int length = -1);

private:
	char *hexStringM;	// ް16i\܂ވꎞɏՕ

	void deleteHexString();
	void newHexString(size_t length);
	void parse(char *hexString, size_t length);
};

#endif // DATABUFFER_H
