//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		MemoryMap.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		MemoryMap͈؂̓eAAVRׯ ؓeɍ\
//				MemoryChunk̈ꗗ(޸)łB͔zƂMemoryMap
//				\ŁÂɓ\̂͂̂悤ɂĎgp҂B
//				B
//
// ̑:
//=============================================================================

#include "MemoryMap.h"
#include "CreateException.h"

//=============================================================================
// {ݽ׸

MemoryMap::MemoryMap(unsigned char emptyFill) : loLimitM(0xffffffff),
	hiLimitM(0x00000000), emptyFillM(emptyFill)
{
	// 
}

//=============================================================================
// Intel HEX`̧قeǂ޺ݽ׸

MemoryMap::MemoryMap(const char *filename, unsigned int start,
					 unsigned int end, unsigned char emptyFill)
	: loLimitM(0xffffffff), hiLimitM(0x00000000), emptyFillM(emptyFill)
{
	if (!filename) return;

	FILE *inFile = fopen(filename, "r");

	if (!inFile)
		throw new CreateException(ERROR_FILE_NOT_FOUND, filename);

	int highAddress = 0;

	while (!feof(inFile))
	{
		char line[300];
		unsigned char length, type;
		int address;

		if (fscanf(inFile, ":%s\n", line) != 1)
			throw new CreateException(ERROR_HEX_FORMAT, filename);

		// (':'܂)in_filěݍsŏ5޲Ă𒷂AڽA`ɓǂ݂܂B
		DataBuffer data(line);

		// т𐔂̧قĂȂƂmɂ܂B
		unsigned char chksum = 0;

		for (unsigned int i = 0; i < data.size(); i++)
			chksum += data[i];

		if (chksum != 0)
			throw new CreateException(ERROR_FILE_DAMAGED, filename);

		length = data[0];
		address = (data[1] << 8) | data[2];
		type = data[3];

		// ް擪CRC苎܂B
		data = data.substr(4, length);

		switch (type)
		{
			// ްL^(8,16,32ޯČ`)
			case 0:
				try
				{
					insert(address + highAddress, data);
				}

				catch (CreateException *e)
				{
					if (e->getCode() == ERROR_OVERLAPPING_DATA)
					{
						ErrorCode code = e->getCode();
						delete e;

						throw new CreateException(code, filename);
					}
					else
						throw e;
				}
				break;

			// ُ̧IL^(8,16,32ޯČ`)
			case 1:
				return;

			// g ڽL^(16,32ޯČ`)
			case 2:
				highAddress = (data[0] << 12) + (data[1] << 4);
				break;

			// Jn ڽL^(16,32ޯČ`)
			case 3:
				break;

			// gڽL^(32ޯČ`)
			case 4:
				highAddress = (data[0] << 24) + (data[1] << 16);
				break;

			// JnڽL^(32ޯČ`)
			case 5:
				break;

			// m̌`
			default:
				throw new CreateException(ERROR_FILE_DAMAGED, filename);
		}
	}
}

//=============================================================================
// ޽׸

MemoryMap::~MemoryMap()
{
	// 
}

//=============================================================================
// ްwꂽ؈ʒuɂȂΐ^Ԃ܂B

bool MemoryMap::in(unsigned int address)
{
	for (MemoryChunk *i = begin(); i != end(); i++)
		if (i->in(address))
			return true;

	return false;
};

//=============================================================================
// ڽwWɂ؂𱸾

unsigned char MemoryMap::operator [] (unsigned int address)
{
	for (MemoryChunk *i = begin(); i != end(); i++)
		if (i->in(address))
			return (*i)[address];

	return emptyFillM;
}

//=============================================================================
// ޼ުĂւ߲ŗeՂɎgp邱ƂAMemoryMap->at()̂悤
// ȏꍇA'operator []'Ɠ
// (ȂΎgp҂͕sDɌ(*MemoryMap)[]Kvł傤B

unsigned char MemoryMap::at(unsigned int address)
{
	return (*this)[address];
}

//=============================================================================
// MemoryChunkMemoryMapɑ}

void MemoryMap::insert(MemoryChunk& chunk)
{
	unsigned int address;

	for (address = chunk.getStartAddress();
		address <= chunk.getEndAddress(); address++)
		if (in(address))
			throw new CreateException(ERROR_OVERLAPPING_DATA, "");

	push_back(chunk);

	if (loLimitM > chunk.getStartAddress())
		loLimitM = chunk.getStartAddress();

	if (hiLimitM < chunk.getEndAddress())
		hiLimitM = chunk.getEndAddress();
}

//=============================================================================
// (ڽƒgꂽ)DataBufferMemoryMapɑ}

void MemoryMap::insert(unsigned int address, const DataBuffer& buffer)
{
	insert(MemoryChunk(address, buffer, emptyFillM));
}

//=============================================================================
// MemoryMapŎgpꂽŒڽ

unsigned int MemoryMap::getLowestAddress()
{
	return loLimitM;
}

//=============================================================================
// MemoryMapŎgpꂽōڽ

unsigned int MemoryMap::getHighestAddress()
{
	return hiLimitM;
}
